SystemOrganization addCategory: #'Meta-Examples'!

MMeta subclass: #MMetaParser
	instanceVariableNames: 'mDefMemo mDefNextPos mExpr1Memo mExpr1NextPos mExpr2Memo mExpr2NextPos mExpr3Memo mExpr3NextPos mExpr4Memo mExpr4NextPos mExprMemo mExprNextPos'
	classVariableNames: 'Primitives'
	poolDictionaries: ''
	category: 'Meta-Examples'!

!MMetaParser class methodsFor: 'instance creation' stamp: 'tfel 8/6/2016 13:04'!
initialize
	"after loading everything, Monticello calls this"
	MMetaCompiler useBootstrap: false.! !

!MMetaParser class methodsFor: 'grammar handling' stamp: 'aw 2/20/2007 18:15'!
tokenizer
	^ MMetaTokenizer! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemDef
	mDefMemo _ Array new: stream size + 1 withAll: Untried.
	mDefNextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr
	mExprMemo _ Array new: stream size + 1 withAll: Untried.
	mExprNextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr1
	mExpr1Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr1NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr2
	mExpr2Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr2NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr3
	mExpr3Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr3NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr4
	mExpr4Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr4NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/6/2007 19:03'!
mDef ::=
	<anything>:n ?`n is: #name` #'::=' <mExpr>:v ~<anything> `{#macroDef:. n value asString. v}`! !

!MMetaParser methodsFor: 'productions' stamp: 'aw 2/20/2007 18:19'!
mExpr ::=
	<mExpr4>:x (#'|' <mExpr4>)*:xs `(Array with: #macroOr: with: x), xs`! !

!MMetaParser methodsFor: 'productions' stamp: 'tfel 8/10/2016 09:57'!
mExpr1 ::=
	#'<' <anything>:n ?`n is: #name` #'>' `{#macroApp:. n value asString}` |
	<anything>:t ?`t isString & t isSymbol not` `{#macroString:. t}` |
	<anything>:t ?`t is: #symbol` `{#macroSymbol:. t value}` |
	<anything>:t ?`t isCharacter` `{#macroCharacter:. t}` |
	<anything>:t ?`t isInterval` `{#macroInterval:. t}` |
	<anything>:t ?`t is: #predCode` `{#macroPred:. t value}` |
	<anything>:t ?`t is: #code` `{#macroAns:. t value}` |
	#'(' <mExpr>:r #')' `r`! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/5/2007 14:56'!
mExpr2 ::=
	#'~' <mExpr2>:e `{#macroNot:. e}` |
	#'&' <mExpr2>:e `{#macroAndP:. e}` |
	<mExpr1>! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/17/2007 19:29'!
mExpr3 ::=
	<mExpr2>:r
	(
		#'*' `{#macroMany:. r}`:r |
		#'+' `{#macroMany1:. r}`:r |
		#'?' `{#macroQuestion:. r}`:r |
		?`true`
	)
	(
		<anything>:t ?`t = #'=>'`
			<anything>:t ?`t = #<`
				<anything>:n ?`n is: #name`
					<anything>:t ?`t = #>`
						`{#macroForm:. r. n value asString}`:r
	)*
	(
		#':' <anything>:n ?`n is: #name` `{#macroBind:. n value asString. r}`:r |
		?`true`
	)
	`r`! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/17/2007 21:45'!
mExpr4 ::=
	<mExpr3>+:r `(Array with: #macroAnd:), r`
! !

MMeta subclass: #MSExpParser
	instanceVariableNames: 'ksexpMemo ksexpNextPos componentMemo componentNextPos nameMemo nameNextPos keywordMemo keywordNextPos stringMemo stringNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!MSExpParser class methodsFor: 'as yet unclassified' stamp: 'yo 3/7/2007 15:21'!
test1

	| str1 str2 str3 |
	str1 _ '(script :name "testscript1:" :type "Player" :player "12"
		(parameter :name "parameter" :type "Number" :position "1") 
		(sequence
			(loop :type "repeat"
				(initial (literal :value "0"))
				(increment (literal :value "1"))
				(test (send :type "Number"
		(selector :selector "+")
		(send :type "Number"
			(selector :getter "x")
			(literal :type "Player" :value "self"))
		(literal :type "Number" :value "1")))
				(sequence
					(assign :type "Number" :updating "Incr:" :property "x"
						(literal :type "Player" :value "4")
						(send :type "Number"
							(selector :selector "+")
							(literal :type "Number" :value "244.0")
							(literal :type "Number" :value "1")))))))'.

	str2 _ (MSExpParser parse: str1 with: #ksexp) prettyString.
	str3 _ (MSExpParser parse: str2 with: #ksexp) prettyString.

	(StringHolder new textContents:
			(TextDiffBuilder buildDisplayPatchFrom: str2 to: str3))
			openLabel: 'original sexp and new sexp'.
! !

!MSExpParser class methodsFor: 'as yet unclassified' stamp: 'yo 2/28/2007 17:21'!
tokenizer

	^ MSExpTokenizer.
! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/28/2007 17:08'!
component ::=
	(<ksexp> | <keyword>:k <string>:s `k->s`)! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializecomponent
	componentMemo _ Array new: stream size + 1 withAll: Untried.
	componentNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializekeyword
	keywordMemo _ Array new: stream size + 1 withAll: Untried.
	keywordNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializeksexp
	ksexpMemo _ Array new: stream size + 1 withAll: Untried.
	ksexpNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializename
	nameMemo _ Array new: stream size + 1 withAll: Untried.
	nameNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializestring
	stringMemo _ Array new: stream size + 1 withAll: Untried.
	stringNextPos _ Array new: stream size + 1! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:09'!
keyword ::=
	<anything>:s ?`s is: #keyword` `s value`
! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:09'!
ksexp ::=
	#'(' <name>:n <component>*:c #')' `SExpElement keyword: n value components: c`! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:10'!
name ::=
	<anything>:s ?`s is: #name` `s value`
! !

!MSExpParser methodsFor: 'productions' stamp: 'yo 2/26/2008 21:11'!
string ::=
	<anything>:s ?`s is: #string` `s value`
! !

MMeta subclass: #MTokenizer
	instanceVariableNames: 'charMemo charNextPos spaceMemo spaceNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

MTokenizer subclass: #MMetaTokenizer
	instanceVariableNames: 'metaCharMemo metaCharNextPos metaCodeMemo metaCodeNextPos metaNameMemo metaNameNextPos metaStringMemo metaStringNextPos metaSymbolMemo metaSymbolNextPos metaSpecialMemo metaSpecialNextPos tokenMemo tokenNextPos tokenizeMemo tokenizeNextPos metaCommentMemo metaCommentNextPos commentMemo commentNextPos whitespaceMemo whitespaceNextPos metaSpecial2Memo metaSpecial2NextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:48'!
comment ::=
	$" (~$" <anything>)* $"! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializecomment
	commentMemo _ Array new: stream size + 1 withAll: Untried.
	commentNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaChar
	metaCharMemo _ Array new: stream size + 1 withAll: Untried.
	metaCharNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaCode
	metaCodeMemo _ Array new: stream size + 1 withAll: Untried.
	metaCodeNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaName
	metaNameMemo _ Array new: stream size + 1 withAll: Untried.
	metaNameNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaSpecial
	metaSpecialMemo _ Array new: stream size + 1 withAll: Untried.
	metaSpecialNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 8/5/2016 15:46'!
initializemetaSpecial2
	metaSpecial2Memo _ Array new: stream size + 1 withAll: Untried.
	metaSpecial2NextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaString
	metaStringMemo _ Array new: stream size + 1 withAll: Untried.
	metaStringNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaSymbol
	metaSymbolMemo _ Array new: stream size + 1 withAll: Untried.
	metaSymbolNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetoken
	tokenMemo _ Array new: stream size + 1 withAll: Untried.
	tokenNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetokenize
	tokenizeMemo _ Array new: stream size + 1 withAll: Untried.
	tokenizeNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializewhitespace
	whitespaceMemo _ Array new: stream size + 1 withAll: Untried.
	whitespaceNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:44'!
metaChar ::=
	$$ <anything>:c1 '..' <anything>:c2 `(Interval from: c1 to: c2)` |
	$$ <anything>! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:44'!
metaCode ::=
	'?`' (~'`' <anything>)*:s '`' `MToken type: #predCode value: (String newFrom: s)` |
	'`' (~'`' <anything>)*:s '`' `MToken type: #code value: (String newFrom: s)`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/7/2016 10:09'!
metaName ::=
	<anything>:c ?`c isLetter` (<anything>:d ?`d isAlphaNumeric` `d`)*:s `MToken type: #name value: (String newFrom: c asString, (s joinSeparatedBy: ''))`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/5/2016 15:45'!
metaSpecial ::=
	$< `#<` |
	$> `#>` |
	$? `#?` |
	$( `#'('` |
	$) `#')'` |
	$~ `#~` |
	<metaSpecial2>:s `s`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/5/2016 15:46'!
metaSpecial2 ::=
	$& `#&` |
	$* `#*` |
	$+ `#+` |
	$| `#|` |
	'::=' `#'::='` |
	'=>' `#'=>'` |
	$: `#:`

! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:48'!
metaString ::=
	$' (&($' $') <anything> <anything> `$'` | ~$' <anything>)*:st $' `String newFrom: st`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:43'!
metaSymbol ::=
	$# <metaName>:n `MToken type: #symbol value: n symbol` |
	$# <metaString>:s `MToken type: #symbol value: (Symbol newFrom: s)`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:42'!
token ::=
	<whitespace> (<metaChar> | <metaCode> | <metaName> | <metaString> | <metaSymbol> | <metaSpecial>)! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'aw 2/20/2007 18:10'!
tokenize ::=
	<token>*! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:42'!
whitespace ::=
	(<space> | <comment>)*! !

MTokenizer subclass: #MSExpTokenizer
	instanceVariableNames: 'parenMemo parenNextPos nameMemo nameNextPos keywordMemo keywordNextPos stringMemo stringNextPos tokenMemo tokenNextPos tokenizeMemo tokenizeNextPos unicodeOneSequenceMemo unicodeOneSequenceNextPos charOrSequenceMemo charOrSequenceNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/8/2007 22:24'!
byteCharCode: u1 and: u2

	^ (('0123456789ABCDEF' indexOf: u1 startingAt: 1 ifAbsent: [0]) - 1) * 16 +
		(('0123456789ABCDEF' indexOf: u2 startingAt: 1 ifAbsent: [0]) - 1).
! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/9/2007 13:18'!
charOrSequence ::=
	<anything>:c ?`c = $"` `nil` |
	<anything>:c ?`c ~= $\ and: [c ~= $"]` `c` |
	<anything>:c ?`c = $\` (
		<unicodeOneSequence>:r ?`16rD800 <= r and: [r <= 16rDBFF]` <unicodeOneSequence>:r2 ?`16rDC00 <= r2 and: [r2 <= 16rDFFF]` `Character value: (r - 16rD800) * 16r400 + (r2 - 16rDC00)` |
		<unicodeOneSequence>:r `Character value: r` |
		<anything>:d ?`d = $x` <anything>:u1 <anything>:u2 `Character value: (self byteCharCode: u1 and: u2)` |
		<anything>:d ?`d = $a` `Character value: 7` |
		<anything>:d ?`d = $b` `Character value: 8` |
		<anything>:d ?`d = $t` `Character value: 9` |
		<anything>:d ?`d = $n` `Character value: 10` |
		<anything>:d ?`d = $v` `Character value: 11` |
		<anything>:d ?`d = $f` `Character value: 12` |
		<anything>:d ?`d = $r` `Character value: 13` |
		<anything>:d ?`d = $e` `Character value: 27` |
		<anything>
	):v `v`
! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializecharOrSequence
	charOrSequenceMemo _ Array new: stream size + 1 withAll: Untried.
	charOrSequenceNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializekeyword
	keywordMemo _ Array new: stream size + 1 withAll: Untried.
	keywordNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializename
	nameMemo _ Array new: stream size + 1 withAll: Untried.
	nameNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializeparen
	parenMemo _ Array new: stream size + 1 withAll: Untried.
	parenNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializestring
	stringMemo _ Array new: stream size + 1 withAll: Untried.
	stringNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetoken
	tokenMemo _ Array new: stream size + 1 withAll: Untried.
	tokenNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetokenize
	tokenizeMemo _ Array new: stream size + 1 withAll: Untried.
	tokenizeNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializeunicodeOneSequence
	unicodeOneSequenceMemo _ Array new: stream size + 1 withAll: Untried.
	unicodeOneSequenceNextPos _ Array new: stream size + 1! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/1/2007 16:36'!
keyword ::=
	$: <name>:n `MToken type: #keyword value: n value`! !

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/1/2007 16:36'!
makeFloat: int and: frac

	| val |
	val _ ((int inject: 0 into: [:subTotal :next | subTotal * 10 + next digitValue]) * 1.0)
		 + (frac reversed inject: 0.0 into: [:subTotal :next | subTotal * 0.1 + (next digitValue * 0.1)]).
	^ MToken type: #float value: val.
! !

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/1/2007 16:36'!
makeInt: int 

	| val |
	val _ int inject: 0 into: [:subTotal :next | subTotal * 10 + next digitValue].
	^ MToken type: #integer value: val.
! !

!MSExpTokenizer methodsFor: 'private' stamp: 'tfel 8/7/2016 10:12'!
makeNameBeginsWith: aCharacter and: restString

	^ MToken type: #name value: (String newFrom: aCharacter asString, (restString joinSeparatedBy: '')) asSymbol.
! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 16:48'!
name ::=
	<char>:c ?`c isLetter` (<char>:d ?`d isAlphaNumeric` `d`)*:s
		`self makeNameBeginsWith: c and: s`! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 16:21'!
paren ::=
	$( `#'('` |
	$) `#')'`
! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/8/2007 22:00'!
string ::=
	$" <charOrSequence>*:s $" `MToken type: #string value: (String newFrom: s)`! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/9/2007 13:21'!
token ::=
	<space>* (<paren> | <keyword> | <name> | <string>)! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 2/28/2007 16:51'!
tokenize ::=
	<token>*! !

!MSExpTokenizer methodsFor: 'private' stamp: 'yo 3/8/2007 22:56'!
unicodeCharCode: u1 and: u2 and: u3 and: u4

	^ ((('0123456789ABCDEF' indexOf: u1 startingAt: 1 ifAbsent: [0]) - 1) * 4096) +
		((('0123456789ABCDEF' indexOf: u2 startingAt: 1 ifAbsent: [0]) - 1) * 256) +
			((('0123456789ABCDEF' indexOf: u3 startingAt: 1 ifAbsent: [0]) - 1) * 16) +
				((('0123456789ABCDEF' indexOf: u4 startingAt: 1 ifAbsent: [0]) - 1)).
! !

!MSExpTokenizer methodsFor: 'productions' stamp: 'yo 3/9/2007 13:12'!
unicodeOneSequence ::=
	<anything>:d ?`d = $u` <anything>:u1 <anything>:u2 <anything>:u3 <anything>:u4 `self unicodeCharCode: u1 and: u2 and: u3 and: u4`! !

!MTokenizer methodsFor: 'productions' stamp: 'aw 2/20/2007 18:12'!
char ::=
	<anything>:c ?`c isCharacter` `c`! !

!MTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializechar
	charMemo _ Array new: stream size + 1 withAll: Untried.
	charNextPos _ Array new: stream size + 1! !

!MTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializespace
	spaceMemo _ Array new: stream size + 1 withAll: Untried.
	spaceNextPos _ Array new: stream size + 1! !

!MTokenizer methodsFor: 'productions' stamp: 'aw 2/20/2007 18:12'!
space ::=
	<char>:c ?`c <= $ ` `c`! !

Object subclass: #ParseNodeBuilder
	instanceVariableNames: 'context encoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 13:17'!
assign: sexp

	| varNode valueNode |
	varNode _ self parse: sexp elements first.
	valueNode _ self parse: sexp elements second.
	^ AssignmentNode new
		variable: varNode
				value: valueNode
				from: encoder
				sourceRange: nil.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/6/2007 09:58'!
blockParameter: sexp

	^ encoder autoBind: (sexp attributeAt: #name) asSymbol.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 13:17'!
condition: sexp

	| selector rec y n |
	selector _ #ifTrue:ifFalse:.
	rec _ self parse: sexp elements first.
	y _ self parse: sexp elements second.
	n _ self parse: sexp elements third.
	^ MessageNode new
				receiver: rec
				selector: selector
				arguments: (Array with: y with: n)
				precedence: (selector precedence)
				from: encoder
				sourceRange: nil.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'tfel 8/7/2016 10:16'!
literal: sexp

	| type value |
	type _ Smalltalk at: (sexp attributeAt: #type ifAbsent: []) asSymbol.
	value _ sexp attributeAt: #value ifAbsent: [].
	(type inheritsFrom: Symbol) ifTrue: [
		value _ '#', value.
	] ifFalse: [
		(type inheritsFrom: String) ifTrue: [
			^ encoder encodeLiteral: value.
		]
	].

	^ encoder encodeLiteral: (type readFromString: value).
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 13:18'!
parameter: sexp

	^ encoder bindArg: (sexp attributeAt: #name).
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 14:13'!
parse: sexp

	^ self perform: (sexp keyword, ':') asSymbol with: sexp.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 13:19'!
return: sexp

	| val |
	val _ self parse: sexp elements first.
	^ ReturnNode new expr: val.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 9/11/2007 15:06'!
script: sexp with: aDictionary in: aWorld

	| playerClassId playerClass selector n selOrFalse argSexp arguments block tmps |
	context _ aDictionary.
	playerClassId _ sexp attributeAt: #playerClass.
	playerClass _ aDictionary at: playerClassId asSymbol ifAbsent: [self error: ''].	
	encoder _ ScriptEncoder new init: playerClass context: nil notifying: nil; referenceObject: aWorld.
	selector _ (sexp attributeAt: #scriptName) asSymbol.
	n _ MethodNode new.
	selOrFalse _ encoder encodeSelector: selector.

	tmps _ sexp elements detect: [:e | e keyword = #temporary] ifNone: [nil].
	tmps ifNotNil: [
		tmps elements  do: [:t |
			self temporary: t.
		].
	].

	argSexp _ (sexp elements select: [:e | e keyword == #parameter]) asSortedCollection: [:a :b | (a attributeAt: #position) asNumber < (b attributeAt: #position) asNumber].
	arguments _ argSexp collect: [:e | self parse: e].
	block _ self parse: (sexp elements detect: [:e | e keyword == #sequence]).
	^ n
		selector: selOrFalse
		arguments: arguments
		precedence: selector precedence
		temporaries: #()
		block: block
		encoder: encoder
		primitive: 0.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 13:21'!
selector: sexp

	| value |
	value _ sexp attributeAt: #selector ifAbsent: [].
	^ encoder encodeSelector: value.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 14:14'!
send: sexp

	| selector rec args |
	selector _ sexp elements first attributeAt: #selector.
	rec _ self parse: sexp elements second.
	args _ (sexp elements copyFrom: 3 to: sexp elements size) collect: [:e |
		self parse: e.
	].
	^ MessageNode new
				receiver: rec
				selector: selector asSymbol
				arguments: args
				precedence: (selector asSymbol precedence)
				from: encoder
				sourceRange: nil.
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 9/11/2007 15:48'!
sequence: sexp

	| statements ret args |
	args _ sexp elements select: [:e | e keyword == #parameter].
	statements _ sexp elements reject: [:e | e keyword == #parameter].
	args _ args collect: [:e | self blockParameter: e].
	statements _ statements collect: [:e | self parse: e].
	ret _ (statements size > 0 and: [statements last isMemberOf: ReturnNode]).
	args do: [:variable | variable scope: -1].
	^ BlockNode new arguments: args statements: statements returns: ret from: encoder.

! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 9/11/2007 15:05'!
temporary: sexp

	| value |
	value _ sexp attributeAt: #value ifAbsent: [].
	^ encoder bindTemp: value asSymbol
! !

!ParseNodeBuilder methodsFor: 'all' stamp: 'yo 4/3/2007 13:24'!
variable: sexp

	| value type |
	value _ sexp attributeAt: #value ifAbsent: [].
	type _ sexp attributeAt: #type ifAbsent: [].
	type = 'Player' ifTrue: [
		value = 'self' ifFalse: [
			value _ sexp attributeAt: #idref
		].
	].
	value first canBeGlobalVarInitial ifTrue: [
		^ encoder encodeVariable: value
	] ifFalse: [
		value first isDigit ifTrue: [
			^ encoder encodeVariable: (context at: value asSymbol) uniqueNameForReference.
		]
	].
	^ encoder encodeVariable: value.
! !

Object subclass: #SExpElement
	instanceVariableNames: 'keyword attributes elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/2/2007 23:17'!
keyword: n

	^ self new keyword: n; newAttributes.

! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 20:39'!
keyword: n attributes: a

	^ self new keyword: n attributes: a.
! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 22:48'!
keyword: n attributes: a elements: e

	^ self new keyword: n attributes: a elements: e.
! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 20:22'!
keyword: n components: c

	| inst elem attrs |
	inst _ self new.
	"dict _ IdentityDictionary new."
	attrs _ WriteStream on: (SExpAttributes new: c size).
	elem _ OrderedCollection new: c size.
	c do: [:e |
		(e isMemberOf: Association) ifTrue: [
			attrs nextPut: e.
			"dict at: e key value put: e value value"
		] ifFalse: [
			elem addLast: e.
		].
	].
	^ inst keyword: n value attributes: attrs contents elements: elem asArray.
! !

!SExpElement class methodsFor: 'instance creation' stamp: 'yo 3/23/2007 20:42'!
keyword: n elements: e

	^ self new keyword: n elements: e.
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/23/2007 20:34'!
addAttributes: assocs

	(attributes isNil or: [attributes isEmpty]) ifTrue: [
		attributes _ assocs.
	] ifFalse: [
		attributes _ attributes, assocs.
	].


	attributes _ attributes, assocs.
"
	assocs do: [:assoc |
		attributes at: assoc key put: assoc value.
	].
"! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/5/2007 12:45'!
addElements: aCollection

	elements ifNil: [
		elements _ aCollection.
	] ifNotNil: [
		elements _ elements, aCollection.
	].
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 2/28/2007 17:25'!
attributeAt: aSymbol

	^ attributes at: aSymbol.
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 2/28/2007 17:25'!
attributeAt: aSymbol ifAbsent: aBlock

	^ attributes at: aSymbol ifAbsent: aBlock.
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 2/28/2007 17:25'!
attributeAt: aSymbol ifPresent: aBlock

	^ attributes at: aSymbol ifPresent: aBlock.
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/22/2007 22:24'!
attributeAt: aSymbol ifPresent: aBlock ifAbsent: absentBlock

	^ (attributes at: aSymbol ifPresent: aBlock) ifNil: [^ absentBlock value].
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/23/2007 19:15'!
attributeAt: aSymbol put: aString

	^ attributes _ attributes copyWith: (aSymbol->aString).
"
	^ attributes at: aSymbol put: aString
"! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/22/2007 21:57'!
attributes

	^ IdentityDictionary new addAll: attributes; yourself.
! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:28'!
elements

	^ elements.
! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 3/5/2007 10:57'!
elementsDo: aBlock

	elements ifNil: [^ self].
	elements do: aBlock.
! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:28'!
elements: aCollection

	elements _ aCollection.
! !

!SExpElement methodsFor: 'attribute accessing' stamp: 'yo 3/21/2007 23:14'!
hasAttribute: attr

	^ attributes includesKey: attr.
! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 3/2/2007 17:51'!
idref

	^ attributes at: #idref ifAbsent: [self error: 'should not happen'].
! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 3/5/2007 11:06'!
idref: aString

	^ attributes at: #idref put: aString.
! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:26'!
keyword

	^ keyword.
! !

!SExpElement methodsFor: 'accessing' stamp: 'yo 3/2/2007 17:26'!
keyword: aSymbol

	keyword _ aSymbol.
! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/23/2007 20:39'!
keyword: n attributes: a

	keyword _ n.
	attributes _ a.
	elements _ #().
! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/2/2007 17:27'!
keyword: n attributes: a elements: e

	keyword _ n.
	attributes _ a.
	elements _ e.
! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/23/2007 20:43'!
keyword: n elements: e

	keyword _ n.
	elements _ e.

! !

!SExpElement methodsFor: 'initialization' stamp: 'yo 3/23/2007 19:01'!
newAttributes

	attributes _ SExpAttributes new.

"
	attributes _ IdentityDictionary new.
"! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/5/2007 17:12'!
prettyPrintOn: aStream

	self prettyPrintOn: aStream indent: 0.
! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/22/2007 21:59'!
prettyPrintOn: aStream indent: tabLevel

	aStream tab: tabLevel.
	aStream nextPutAll: '('.
	aStream nextPutAll: keyword.

	attributes notNil ifTrue: [
		attributes associations size > 0 ifTrue: [aStream space].
		attributes associations do: [:assoc |
			aStream nextPut: $:.
			aStream nextPutAll: assoc key.
			aStream space.
			aStream nextPut: $".
			aStream nextPutAll: assoc value sissEscape.
			aStream nextPut: $".
		] separatedBy: [aStream space].
	].

	(elements notNil and: [elements size > 0]) ifTrue: [
		elements do: [:each |
			aStream cr.
			each prettyPrintOn: aStream indent: tabLevel+1.
		].
	].

	aStream nextPutAll: ')'.
			
	! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/22/2007 21:59'!
prettyPrintOn: aStream indent: tabLevel sort: sortBlock

	aStream tab: tabLevel.
	aStream nextPutAll: '('.
	aStream nextPutAll: keyword.

	attributes notNil ifTrue: [
		attributes associations size > 0 ifTrue: [aStream space].
		attributes associations do: [:assoc |
			aStream nextPut: $:.
			aStream nextPutAll: assoc key.
			aStream space.
			aStream nextPut: $".
			aStream nextPutAll: assoc value sissEscape.
			aStream nextPut: $".
		] separatedBy: [aStream space].
	].

	(elements notNil and: [elements size > 0]) ifTrue: [
		(elements asSortedCollection: sortBlock) do: [:each |
			aStream cr.
			each prettyPrintOn: aStream indent: tabLevel+1.
		].
	].

	aStream nextPutAll: ')'.
			
	! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/20/2007 21:47'!
prettyPrintOn: aStream sort: sortBlock

	self prettyPrintOn: aStream indent: 0 sort: sortBlock.
! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/5/2007 17:14'!
prettyString

	| w |
	w _ WriteStream on: (String new: 1000).
	self prettyPrintOn: w indent: 0.
	^ w contents.
! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/20/2007 21:48'!
prettyStringWithSorting

	| w |
	w _ WriteStream on: (String new: 1000).
	self prettyPrintOn: w indent: 0 sort: [:a :b | a idref asNumber < b idref asNumber].
	^ w contents.
! !

!SExpElement methodsFor: 'printing' stamp: 'yo 3/22/2007 22:03'!
printOn: aStream

	aStream nextPutAll: '('.
	aStream nextPutAll: keyword.
	aStream space.

	attributes notNil ifTrue: [
		attributes associations do: [:assoc |
			aStream nextPut: $:.
			aStream nextPutAll: assoc key.
			aStream space.
			aStream nextPut: $".
			aStream nextPutAll: assoc value sissEscape.
			aStream nextPut: $".
		] separatedBy: [aStream space].
	].

	(elements notNil and: [elements size > 0]) ifTrue: [
		aStream space.
		elements do: [:each |
			each printOn: aStream.
		] separatedBy: [aStream space].
	].

	aStream nextPutAll: ')'.
			
	! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 4/5/2007 22:08'!
sissReadObjects

	^ self sissReadObjectsAsEtoysProject: false.
! !

!SExpElement methodsFor: 'serialization specific' stamp: 'yo 4/5/2007 22:08'!
sissReadObjectsAsEtoysProject

	^ self sissReadObjectsAsEtoysProject: true.
! !

!SExpElement methodsFor: 'serialization specific' stamp: 'tfel 8/9/2016 15:30'!
sissReadObjectsAsEtoysProject: aBoolean

	| to from root ret w sel |
	to _ SISSDictionaryForReading new initialize.
	from _ IdentityDictionary new.
	(elements isNil or: [elements isEmpty]) ifTrue: [
		^ self fromSexp: self from: from to: to.
	].

	root _ self attributeAt: #root.
	elements do: [:e |
		e attributeAt: #idref ifPresent: [:id |
			from at: id asSymbol put: e
		].
	].

	w _ elements detect: [:e | (e attributeAt: #idref ifAbsent: []) = root].
	ret _ self fromSexp: w from: from to: to.
	from do: [:v | (v keyword = #SISSProxy) ifTrue: [
		sel _ (v attributeAt: #selector) asSymbol.
		(SISSProxy class methodDict includesKey: sel) ifTrue: [
			to at: v idref asSymbol put: (SISSProxy perform: sel)]]].
	to do: [:e | e sissComeFullyUpOnReloadFrom: from to: to].
	^ ret.
! !

Array variableSubclass: #SExpAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/22/2007 21:58'!
associations

	^ self.
! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 21:15'!
at: key

	^ self at: key ifAbsent: [self error: 'key not found'].
! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 21:08'!
at: key ifAbsent: aBlock

	self do: [:assoc |
		assoc key == key ifTrue: [^ assoc value].
	].
	^ aBlock value.
! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 21:08'!
at: key ifPresent: aBlock

	self do: [:assoc |
		assoc key == key ifTrue: [^ aBlock value: assoc value].
	].
	^ nil.
! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:09'!
do: aBlock 

	1 to: self size do:
		[:index | aBlock value: (self basicAt: index)]! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:12'!
do: elementBlock separatedBy: separatorBlock

	1 to: self size do:
		[:index |
		index = 1 ifFalse: [separatorBlock value].
		elementBlock value: (self basicAt: index)]! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:08'!
includesKey: attr

	1 to: self size do: [:i |
		(self basicAt: i) key == attr ifTrue: [^ true].
	].
	^ false.
! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:00'!
isNil

	^ (self size = 0).
! !

!SExpAttributes methodsFor: 'as yet unclassified' stamp: 'yo 3/23/2007 19:01'!
notNil

	^ self isNil not.
! !
MMetaParser initialize!
